// Fake_Keyboard.h
// Send synthetic keypresses to an X Display.
//
// Copyright (C) 2000 Bradley D. LaRonde <brad@ltc.com>
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#ifndef __FAKE_KEYBOARD_H
#define __FAKE_KEYBOARD_H

#include <vector>
#include <X11/extensions/XTest.h>
#define XK_LATIN1
#define XK_MISCELLANY
#include <X11/keysymdef.h>
#include <X11/Xproto.h>

class Fake_Keyboard {
private:
	Display* display;
	int minkeycode, maxkeycode;
	KeySym* mapping;
	int keysyms_per;
	std::vector<int> modifier_stack;
	bool meta_key;


public:
	void find(KeySym sym, int* keycode, bool* shift, bool* control);
	Fake_Keyboard(Display* d);
	~Fake_Keyboard();
	void set_display(Display* d);
	void press(KeySym sym);
	void press_modifier(KeySym sym);
	void release_modifier(KeySym sym);
	void release_modifier();
	void press_meta();
	void release_meta();
};

#endif
