// -*- mode: c; mode: fold -*-

#ifndef _AQW_H_
#define _AQW_H_


// define to omit highlighting of ALT and CTRL
#define _AQW_SIMPLEINTERFACE

#define MAX_ZONES 3

// fake keyboard:
#define XK_LATIN1
#define XK_MISCELLANY
#include <X11/keysymdef.h>
#include <X11/Xproto.h>
#include "Fake_Keyboard.h"
#include <FL/x.H>                    // fake keyboard

                                         
typedef enum
{
  AQWMODE_LOWERCASE = 0,
    AQWMODE_UPPERCASE,
    AQWMODE_NUMBER,
    AQWMODE_SYMBOL
} inputmodes;

class AQW 
{
  
  public:
   AQW(Fake_Keyboard* fkbd);
   
  
   void offset(int X, int Y);      
   int  handle(int);
   bool needToRedraw() { return(fRedraw);     }
   void redrawDone()   { fRedraw = false;     }
   int  inputMode()    { return(input_mode_); }
   
   bool inputLock();
   bool meta()         { return(meta_key_ != 0);   }
   bool ctrl()         { return(ctrl_key_ != 0);   }
   
  private:
   Fake_Keyboard*          fakeKbd;
   
   int                     last_zone_;
   int                     zone_ctr_;
   int                     zone_list_[MAX_ZONES];
   int                     input_mode_;
   int                     input_lock_;
   int                     meta_key_;
   int                     ctrl_key_;
   
   int                     uOffsetX, uOffsetY;
   bool                    fRedraw;
   
   
   int  which_zone(int x, int y);
   int  interpret_stroke();
   int* get_current_set();
   void change_mode(int mode);
   int  check_special_char(int ch);
   void hit_key(int key);
};

#endif
