#include "configfile.h"

#include <fstream>
#include "tools.h"


MuPOConfig mupoconfig;

void ReadConfigFile()
{
  // set defaults
  mupoconfig.editor = "/etc/alternatives/emacs";
  
  // read file
  std::string homepath = GetHomeDir();
  if (homepath.length() != 0)
  {        
    std::string   filename = homepath + "/.muporc/mupo.config";
    std::ifstream infile;
    std::string   line;
  
    infile.open(filename.c_str());
    if (infile)
    {
      while (!infile.eof())
      {
        line = readfLine(infile);
        if (line.find("=") != std::string::npos)
        {
          if (line.find("editor") == 0)
          {
            mupoconfig.editor = trim(line.substr(line.find("=")+1));
            printf("user config: editor = %s\n", mupoconfig.editor.c_str());
          }
          else if (line.find("default") == 0)
          {
            mupoconfig.defaultfiles.push_back(trim(line.substr(line.find("=")+1)));
            printf("user config: default = %s\n", mupoconfig.defaultfiles[mupoconfig.defaultfiles.size()-1].c_str());
          }  
        }
      }      
      infile.close();    
    }
  }
      
  if (mupoconfig.defaultfiles.size() == 0)
  {
    mupoconfig.defaultfiles.push_back("~/.mupo/mupo_default.dat");
    mupoconfig.defaultfiles.push_back("~/mupo/mupo_default.dat");
    mupoconfig.defaultfiles.push_back("mupo_default.dat");
  }
}
