// -*- mode: c; mode: fold -*-

#ifndef __DATETIME_H
#define __DATETIME_H


typedef unsigned int t_datetime;

#define DATETIME_NODATE     0x80000000
#define DATETIME_NOTIME     0x00004000

#define DATETIME_NOTIMEMASK 0xFFFFC000

#define GETDATEONLY(n)            ((n | DATETIME_NOTIME) & DATETIME_NOTIMEMASK)

#define ISDATESET(n)              ((n & DATETIME_NODATE) == 0)
#define SETDATE(n,year,month,day) n = ((n) & 0x00007FFF) | (((year-2000) & 0x7F) << 24) | (((month) & 0xF) << 20) | (((day) & 0x1F) << 15)
#define CLEARDATE(n)              n = (n & 0x00007FFF) | DATETIME_NODATE
#define GETYEAR(n)                (((n >> 24) & 0x7F) + 2000)
#define GETMONTH(n)               ( (n >> 20) & 0x0F)
#define GETDAY(n)                 ( (n >> 15) & 0x1F)

#define ISTIMESET(n)              ((n & DATETIME_NOTIME) == 0)
#define SETTIME(n,hour,minute)    n = (n & 0xFFFF8000) | ((hour & 0x1F) << 9) | ((minute & 0x3F) << 3)
#define CLEARTIME(n)              n = (n & 0xFFFF8000) | DATETIME_NOTIME
#define GETHOUR(n)                ((n >> 9) & 0x1F)
#define GETMINUTE(n)              ((n >> 3) & 0x3F)

#endif
