void SpecialDays::fillVarLists(int year)
{
  int nOsterMonat, nOsterTag;

  clearList(varFree);
  clearList(var);
  
  nCurYear = year;
  
  ostern(nOsterTag, nOsterMonat, year);
  
  // 1. Berechnung von "variablen" Feiertagen
  //    Ostern
  //    Christi Himmelfahrt
  //    Pfingsten
  //    Fronleichnam
  
  
  // Ostersonntag
  addToList(varFree, nOsterTag,  nOsterMonat, "Ostern");
  
  // Ostermontag
  nOsterTag++;
  if (nOsterTag > MaxTag(nOsterMonat, year))
    {
      nOsterTag -= MaxTag(nOsterMonat, year);
      nOsterMonat++;
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Ostern");
  
  // Karfreitag
  nOsterTag -= 3;
  if (nOsterTag < 1)
    {
      nOsterMonat--;
      nOsterTag += MaxTag(nOsterMonat, year);
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Karfreitag");

  // Christi Himmelfahrt
  nOsterTag += (39 + 2);
  while (nOsterTag > MaxTag(nOsterMonat, year))
    {
      nOsterTag -= MaxTag(nOsterMonat, year);
      nOsterMonat++;
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Himmelfahrt");

  // Pfingstsonntag
  nOsterTag += 10;
  while (nOsterTag > MaxTag(nOsterMonat, year))
    {
      nOsterTag -= MaxTag(nOsterMonat, year);
      nOsterMonat++;
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Pfingsten");

  // Pfingstmontag
  nOsterTag++;
  while (nOsterTag > MaxTag(nOsterMonat, year))
    {
      nOsterTag -= MaxTag(nOsterMonat, year);
      nOsterMonat++;
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Pfingsten");
  
  // Fronleichnam
  nOsterTag += 10;
  while (nOsterTag > MaxTag(nOsterMonat, year))
    {
      nOsterTag -= MaxTag(nOsterMonat, year);
      nOsterMonat++;
    }
  addToList(varFree, nOsterTag,  nOsterMonat, "Fronleichnam");
    

  // 2. Berechnung von anderen besonderen Tagen
  // Der Muttertag ist der zweite Sonntag im Mai
  // Umstellung Sommer/Winterzeit Die Sommerzeit beginnt also am letzten Sonntag 
  //       des Monats März und endet am letzten Sonntag des Monats Oktober.
  //       März: Uhr vorstellen!
  // Aschermittwoch
  ostern(nOsterTag, nOsterMonat, year);
  
  // Aschermittwoch
  nOsterTag -= 46;
  while (nOsterTag < 1)
    {
      nOsterMonat--;
      nOsterTag += MaxTag(nOsterMonat, year);
    }
  addToList(var, nOsterTag,  nOsterMonat, "Aschermittwoch");
  
  // Muttertag
  nOsterTag = 14 - Wochentag(1, 5, year);
  addToList(var, nOsterTag,  5, "Muttertag");

  // Beginn Sommerzeit
  nOsterTag = 7 - Wochentag(1, 3, year);
  while (nOsterTag+7 < 32)
    nOsterTag += 7;
  addToList(var, nOsterTag,  3, "Sommerzeit: Uhr vorstellen!");

  // Beginn Winterzeit
  nOsterTag = 7 - Wochentag(1, 10, year);
  while (nOsterTag+7 < 32)
    nOsterTag += 7;
  addToList(var, nOsterTag,  10, "Winterzeit: Uhr zurückstellen!");
}

void SpecialDays::fillFixedLists()
{
  addToList(fixedFree,  1,  1, "Neujahr");
  addToList(fixedFree,  6,  1, "Heilige Drei Könige");
  addToList(fixedFree,  1,  5, "Maifeiertag");
  addToList(fixedFree,  3, 10, "Tag d. dt. Einheit");
  addToList(fixedFree,  1, 11, "Allerheiligen");
  addToList(fixedFree, 24, 12, "Heiligabend");
  addToList(fixedFree, 25, 12, "1. Weihnachtstag");
  addToList(fixedFree, 26, 12, "2. Weihnachtstag");
  
  addToList(fixed, 14,  2, "Valentinstag");
#ifdef CAL_DE_HALLOWEEN
  addToList(fixed, 31,  10, "Halloween");
#endif
  addToList(fixed,  6, 12, "Nikolaus");
  addToList(fixed, 31, 12, "Silvester");
}
