void SpecialDays::fillVarLists(int year)
{
  int nEasterMonth, nEasterDay;

  clearList(varFree);
  clearList(var);
  
  nCurYear = year;
  
  ostern(nEasterDay, nEasterMonth, year);
  
  // 1. Calculation of variable holidays
  //    Easter
  //    Ascension Day
  //    Whit Sunday
  //    Corpus Christi
  
  
  // Easter Day
  addToList(var, nEasterDay,  nEasterMonth, "Easter Day");
  
  // Easter Monday
  nEasterDay++;
  if (nEasterDay > MaxTag(nEasterMonth, year))
    {
      nEasterDay -= MaxTag(nEasterMonth, year);
      nEasterMonth++;
    }
  addToList(varFree, nEasterDay,  nEasterMonth, "Easter Monday");
  
  // Good Friday
  nEasterDay -= 3;
  if (nEasterDay < 1)
    {
      nEasterMonth--;
      nEasterDay += MaxTag(nEasterMonth, year);
    }
  addToList(var, nEasterDay,  nEasterMonth, "Good Friday");

  // Ascension Day
  nEasterDay += (39 + 2);
  while (nEasterDay > MaxTag(nEasterMonth, year))
    {
      nEasterDay -= MaxTag(nEasterMonth, year);
      nEasterMonth++;
    }
  addToList(varFree, nEasterDay,  nEasterMonth, "Ascension Day");

  // Whit Sunday
  nEasterDay += 10;
  while (nEasterDay > MaxTag(nEasterMonth, year))
    {
      nEasterDay -= MaxTag(nEasterMonth, year);
      nEasterMonth++;
    }
  addToList(var, nEasterDay,  nEasterMonth, "Whit Sunday");

  // Corpus Christi
  nEasterDay += 10;
  while (nEasterDay > MaxTag(nEasterMonth, year))
    {
      nEasterDay -= MaxTag(nEasterMonth, year);
      nEasterMonth++;
    }
  addToList(var, nEasterDay,  nEasterMonth, "Corpus Christi");
    

  // Calculation of other special days
  // Change from summer to winter time begins on the last Sunday of
  //       March and ends on the last Sunday of October
  //       March: clocks go FORWARD
  ostern(nEasterDay, nEasterMonth, year);
  
  // Ash Wednesday
  nEasterDay -= 46;
  while (nEasterDay < 1)
    {
      nEasterMonth--;
      nEasterDay += MaxTag(nEasterMonth, year);
    }
  addToList(var, nEasterDay,  nEasterMonth, "Ash Wednesday");
  
  // Begin Summer Time
  nEasterDay = 7 - Wochentag(1, 3, year);
  while (nEasterDay+7 < 32)
    nEasterDay += 7;
  addToList(var, nEasterDay,  3, "Clocks Go Forward!");

  // Begin Winter Time (Mean Time)
  nEasterDay = 7 - Wochentag(1, 10, year);
  while (nEasterDay+7 < 32)
    nEasterDay += 7;
  addToList(var, nEasterDay,  10, "Clocks Go Back!");

  // UK bank holidays (BH)
  // Spring BH is 1st monday in may
  // May BH is last monday in may
  // last mon in august is august BH

  // Spring BH
  nEasterDay = 1 - Wochentag(1, 3, year);
  if (nEasterDay < 1)
    nEasterDay += 7;
  addToList(var, nEasterDay,  5, "Spring Bank Holiday");

  // May BH
  nEasterDay = 1 - Wochentag(1, 5, year);
  while (nEasterDay+7 < 32)
    nEasterDay += 7;
  addToList(var, nEasterDay,  5, "May Bank Holiday");

  // August Bank Holiday
  nEasterDay = 1 - Wochentag(1, 8, year);
  while (nEasterDay+7 < 32)
    nEasterDay += 7;
  addToList(var, nEasterDay,  8, "August Bank Holiday");

}

void SpecialDays::fillFixedLists()
{
  addToList(fixedFree,  1,  1, "New Year's Day");
  addToList(fixed,  6,  1, "Twelfth Night");
  addToList(fixedFree, 25, 12, "Christmas Day");
  addToList(fixedFree, 26, 12, "Boxing Day");
  
  addToList(fixed, 14,  2, "Valentine's Day");
  addToList(fixed, 31, 12, "New Year's Eve");
}
