static void cb_Done (Fl_Button *, void *) 
{
  mainWin->CB_Done();
}

static void cb_Cancel (Fl_Button *, void *) 
{
  mainWin->CB_Cancel();
}

static void cb_hideKbd (Fl_Button *, void *) 
{
  mainWin->CB_hideKbd();
}

static void cb_listView (Fl_Browser *, void *) 
{
  mainWin->listViewClicked ();
}

static void cb_Up (Fl_Button *, void *) 
{
  mainWin->CB_Up();
}

static void cb_Menu_newTodo   (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_newTodo();
}

static void cb_Menu_newGroup  (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_newGroup();
}

static void cb_Menu_editGroup (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_editGroup();
}

static void cb_Menu_delGroup (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_delGroup();
}

static void cb_Menu_delCompl  (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_delCompl();
}

static void cb_showScreen  (Fl_Menu_ * o, void * item) 
{
  mainWin->showMain((int)item);
}

static void cb_Menu_search  (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_search();
}

static void cb_Menu_insFile  (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_insFile();
}

#ifdef DIRTYTRANSHACK
static void cb_translate     (Fl_Menu_ * o, void *) 
{
  mainWin->inputBox->label("expression to translate:");
  mainWin->inputUse = INPUTUSE_TRANSLATE;
  mainWin->showMain(MAINVISIBLE_INPUT);
}
#endif

static void cb_Menu_expFileGroup     (Fl_Menu_ * o, void *) 
{
  mainWin->inputBox->label("filename and path of MuPO-file to export to:");
  mainWin->inputUse = INPUTUSE_EXPGROUP;
  mainWin->showMain(MAINVISIBLE_INPUT);
}
static void cb_Menu_expFileContent   (Fl_Menu_ * o, void *) 
{
  mainWin->inputBox->label("filename and path of MuPO-file to export to:");
  mainWin->inputUse = INPUTUSE_EXPCONT;
  mainWin->showMain(MAINVISIBLE_INPUT);
}

static void cb_Menu_copyGroup      (Fl_Menu_ * o, void *) 
{
  mainWin->mupo->exportGroupToFile(mainWin->tmpfilename);
}

static void cb_Menu_copyContent    (Fl_Menu_ * o, void *) 
{
  mainWin->mupo->exportContentToFile(mainWin->tmpfilename);
}

static void cb_Menu_paste        (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Menu_paste();
}

static void cb_Opts_View_sort (Fl_Menu_ * o, void * item) 
{
  mainWin->CB_Opts_sort((int)item);
}
static void cb_Opts_View_flat (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Opts_View_flat();
}
static void cb_Opts_View_tree (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Opts_View_tree();
}
static void cb_Opts_View_scompleted (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Opts_View_scompleted();
}
static void cb_Opts_View_completedl (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Opts_View_completedl();
}

static void cb_Opts_View_toggleTextSize (Fl_Menu_ * o, void *) 
{
  mainWin->CB_Opts_View_toggleTextSize();
}

static void cb_Menu_MuPOView(Fl_Menu_ * o, void *item) 
{
  mainWin->CB_Menu_MuPOView((int)item);
}

static void cb_CalSpan(Fl_Menu_ * o, void *item) 
{
  mainWin->mupo->setCalSpan((int)item);
  mainWin->showList();
}

static void cb_CalFirstDay(Fl_Menu_ * o, void *item) 
{
  t_datetime   dt;
  int          year, month, day;
  DateSelect*  dateselect;
  
  dt = mainWin->mupo->getCalFirstDay();
  
  switch ((int)item)
  {
    case CALFIRSTDAY_TODAY:
      dt = getTodayDate(DATETIME_NOTIME);
      break;
    case CALFIRSTDAY_INCL:
      moveDate(dt, mainWin->mupo->getCalSpan());
      break;
    case CALFIRSTDAY_DECL:
      moveDate(dt, -1*mainWin->mupo->getCalSpan());
      break;
    case CALFIRSTDAY_INC:
      moveDate(dt, 1);
      break;
    case CALFIRSTDAY_DEC:
      moveDate(dt, -1);
      break;
    case CALFIRSTDAY_SELECT:
      year  = GETYEAR(dt);
      month = GETMONTH(dt);
      day   = GETDAY(dt);
      
      dateselect = new DateSelect(&year, &month, &day);
      dateselect->show();
      while (dateselect->visible())
        Fl::wait();
      
      if (day != -1)
        SETDATE(dt, year, month, day);
      break;
  }  
  mainWin->mupo->setCalFirstDay(dt);
  mainWin->showList();
}

static void cb_Menu_Crypt_AddPwd(Fl_Menu_ * o, void *)
{
  if (mainWin->mupo->crypt.CanAddPwd())
    pwd_add_run_window(&(mainWin->mupo->crypt));

  mainWin->UpdateCryptMenu();
}

static void cb_Menu_Crypt_Login(Fl_Menu_ * o, void *)
{
  if (mainWin->mupo->crypt.CanLogIn())
    pwd_ask_run_window(&(mainWin->mupo->crypt));
  
  mainWin->UpdateCryptMenu();
}

static void cb_Menu_ActOnSel(Fl_Menu_ * o, void* action)
{
  mainWin->ActOnSelected((int)(action));
}
