static void cb_editToDo_StrtStp (Fl_Button *, void *) 
{
  mainWin->CB_editToDo_StrtStp();
}

static void cb_editToDo_ExtEdit (Fl_Button *, void *) 
{
  mainWin->CB_editToDo_ExtEdit();
}

static void cb_edit_isToDo         (Fl_Menu_ * o, void *) 
{
  mainWin->CB_edit_Pr(-1);
  mainWin->editToDo_updateTimeThings();
}

static void cb_editToDo_showAs         (Fl_Menu_ * o, void * item) 
{
  mainWin->CB_editToDo_showAs((int)item);
}

void MuPOGUI::CB_editToDo_showAs(int n) 
{
  mupo->setShowTimeAs(n);
  editToDoShowAsBusy->value(n);
}

static void cb_editToDo_Pr               (Fl_Menu_ * o, void *item) 
{
  mainWin->CB_edit_Pr((int)item);
}

static void cb_editToDo_compl            (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_compl();
}


#ifndef NOX11
static void cb_editToDo_UpB              (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_UpB();
}

static void cb_editToDo_DwnB             (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_DwnB();
}

static void cb_kbdLeft                   (Fl_Menu_ * o, void *) 
{
  mainWin->CB_kbdLeft();
}

static void cb_kbdRight                  (Fl_Menu_ * o, void *) 
{
  mainWin->CB_kbdRight();
}
#endif

static void cb_editToDo_Menu_t2Group     (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_Menu_t2Group();
}

static void cb_editToDo_Menu_del         (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_Menu_del();
}

static void cb_editToDo_Menu_showGroup   (Fl_Menu_ * o, void *) 
{
  mainWin->CB_editToDo_Menu_showGroup();
}

static void cb_editToDo_Menu_copyToDo    (Fl_Menu_ * o, void *) 
{
  mainWin->mupo->exportToDoToFile(mainWin->tmpfilename);
}

static void cb_editToDo_Date    (Fl_Menu_ * o, void * code) 
{
  int         n;
  int         year, month, day;
  t_datetime  dt, dt2;
  int         min, hour;
  DateSelect* dateselect;
  int         nDiff;
  
  n = (int)code & 0xF0;
  
  switch ((int)code & 0x0F)
  {
    case DATECODE_None:
      mainWin->mupo->clearDate(n);
      break;
    case DATECODE_Today:
      mainWin->mupo->setDateToday(n);
      break;
    case DATECODE_30min:
      dt      = mainWin->mupo->getDateTime(DATECODE_Begin);
      if (ISDATESET(dt))
      {
        day     = GETDAY(dt);
        month   = GETMONTH(dt);
        year    = GETYEAR(dt);
        if (ISTIMESET(dt))
        {
          min     = GETMINUTE(dt) + 30;
          hour    = GETHOUR(dt);
          if (min > 59)
          {
            min -= 60;
            hour++;
            if (hour > 23)
            {
              hour--;
              day++;
              if (day > MaxTag(month, year))
              {
                day = 1;
                month++;
                if (month > 12)
                {
                  month = 1;
                  year++;
                }
              }
            }
          }
          mainWin->mupo->setTime(DATECODE_End, hour, min);
        }
        else
          mainWin->mupo->clearTime(DATECODE_End);
        mainWin->mupo->setDate(DATECODE_End, year, month,day);
      }
      break;
    case DATECODE_Select:
      
      dt = mainWin->mupo->getDateTime(n);
      nDiff = -1;
      if ISDATESET(dt)
      {
        year  = GETYEAR(dt);
        month = GETMONTH(dt);
        day   = GETDAY(dt);
        
        if (n == DATECODE_Begin && ISDATESET(mainWin->mupo->getDateTime(DATECODE_End)))
          nDiff = getDateDiff(mainWin->mupo->getDateTime(DATECODE_End), dt);
      }
      else        
        day = -1;
      
      dateselect = new DateSelect(&year, &month, &day);
      dateselect->show();
      while (dateselect->visible())
        Fl::wait();
      
      if (day != -1)
      {          
        if (nDiff != -1)
        {
          SETDATE(dt2, year, month, day);
          moveDate(dt2, nDiff);
          
          if (getDateDiff(dt, dt2) > 0)
          {
            mainWin->mupo->setDate(DATECODE_Begin, year, month, day);
            mainWin->mupo->setDate(DATECODE_End, GETYEAR(dt2), GETMONTH(dt2), GETDAY(dt2));
          }
          else
          {
            mainWin->mupo->setDate(DATECODE_End, GETYEAR(dt2), GETMONTH(dt2), GETDAY(dt2));
            mainWin->mupo->setDate(DATECODE_Begin, year, month, day);
          }
        }
        else
        {
          mainWin->mupo->setDate(n, year, month, day);
        }
      }
      
      break;
  }
  
  mainWin->editToDo_updateTimeThings();
}

static void cb_editToDo_Time   (Fl_Menu_ * o, void * code) 
{
  int         hour, min;
  int         n = (int)code & 0xF0;
  t_datetime  dt, dt2 = DATETIME_NODATE | DATETIME_NOTIME;
  TimeSelect* timeselect;
  int         nDiff;
  
  switch ((int)code & 0x0F)
  {
    case DATECODE_None:
      mainWin->mupo->clearTime(n);
      break;
    case DATECODE_Select:
      dt = mainWin->mupo->getDateTime(n);
      nDiff = 0;
      if ISTIMESET(dt)
      {
        hour  = GETHOUR(dt);
        min   = GETMINUTE(dt);
        
        dt2   = dt;
        
        if (n == DATECODE_Begin && ISTIMESET(dt2))
          nDiff = 1;
        
      }
      else 
      {
        // JWWTODO: schlaue defaults machen!
        hour  = 8;
        min   = 0;
      }
      
      timeselect = new TimeSelect(&hour, &min);
      timeselect->show();
      while (timeselect->visible())
        Fl::wait();
      
      if (min != -1)
      {
        if (nDiff == 1)
        {
          nDiff = (hour - GETHOUR(dt2))*60 + min - GETMINUTE(dt2);
          // Anfangszeit wurde um nDiff Minuten nach hinten verschoben.
          // Das wird jetzt auch mit der Endezeit gemacht.
          dt = mainWin->mupo->getDateTime(DATECODE_End);
          
          
          moveDateTime(dt, nDiff);
          
          if (nDiff > 0)
          {
            mainWin->mupo->setDate(DATECODE_End, GETYEAR(dt), GETMONTH(dt), GETDAY(dt));
            mainWin->mupo->setTime(DATECODE_End, GETHOUR(dt), GETMINUTE(dt));
            mainWin->mupo->setTime(DATECODE_Begin, hour, min);                  
          }
          else
          {
            mainWin->mupo->setTime(DATECODE_Begin, hour, min);                  
            mainWin->mupo->setDate(DATECODE_End, GETYEAR(dt), GETMONTH(dt), GETDAY(dt));
            mainWin->mupo->setTime(DATECODE_End, GETHOUR(dt), GETMINUTE(dt));
          }
        }
        else
          mainWin->mupo->setTime(n, hour, min);
      }
      break;
  }
  
  mainWin->editToDo_updateTimeThings();
}

static void cb_editToDo_recurring    (Fl_Button * o, void *) 
{
  RecurrenceSelect* recselect;
  T_recData         recData;
  t_datetime        dt;
  bool              fToDo;
  
  mainWin->mupo->getRecData(recData);
  fToDo = (mainWin->mupo->getItemPriority() <= PRIORITY_TODOMAX);
  if (fToDo)
    dt = mainWin->mupo->getDateTime(DATECODE_End);
  else
    dt = mainWin->mupo->getDateTime(DATECODE_Begin);
  
  recselect = new RecurrenceSelect(&recData, 
                                   GETDAY(dt), 
                                   GETMONTH(dt), 
                                   Wochentag(GETDAY(dt), GETMONTH(dt), GETYEAR(dt)),
                                   fToDo);
  recselect->show();
  while (recselect->visible())
    Fl::wait();
  
  if (recData.nType != -1)
  {
    mainWin->mupo->setRecData(recData);
    mainWin->mupo->sanitizeTimeThings();
  }
  
  mainWin->editToDo_updateRecThings();
}

#ifdef REMINDER
static void cb_editToDo_reminder     (Fl_Button * o, void *) 
{
}
#endif

static void cb_editToDo_crypt        (Fl_Check_Button * o, void *) 
{
  mainWin->mupo->SetItemSaveCrypt(o->value() != 0);
}
