// Configuration switches as mentioned in the docs

#define CAL_DE_HALLOWEEN
#define _PARANOIDBACKUPFILES
#define _USESYNC
#define QUIKWRITING_1_0

// Define 300 if you modified your agenda's step-up-converter to 
// output 3.00 V. If it converts to 3.30V (the normal case),
// define 330.
#include "voltage.h"





// Usually you won't modify anything below


#if VOLTAGE == 300
#define VOLTAGE_MUL 19200
#define VOLTAGE_SH  16
#endif

#if VOLTAGE == 330
#define VOLTAGE_MUL 21120
#define VOLTAGE_SH  16
#endif

#define INITIALPRIORITY  3
#define INITIALSC        true
#define INITIALCL        true
#define INITIALISC       false
#define INITIAL_DATETIME (DATETIME_NODATE | DATETIME_NOTIME)

#define PRIORITY_TODOMAX       6
#define PRIORITY_APPOINTMENT 100
#define PRIORITY_NOTE        200
// the following are only defined for T_viewDataItem:
#define PRIORITY_NEWDAY      300
#define PRIORITY_DAYINFO     301
#define PRIORITY_BLANK       400





#define DATECODE_End           0x00
#define DATECODE_Begin         0x10
#define DATECODE_None          0x01
#define DATECODE_Select        0x02
#define DATECODE_Today         0x04
#define DATECODE_30min         0x08

#define DATECODE_EndNone       (DATECODE_End   + DATECODE_None)
#define DATECODE_EndToday      (DATECODE_End   + DATECODE_Today)
#define DATECODE_EndSelect     (DATECODE_End   + DATECODE_Select)
#define DATECODE_EndBegin30min (DATECODE_End   + DATECODE_30min)
#define DATECODE_BeginNone     (DATECODE_Begin + DATECODE_None)
#define DATECODE_BeginToday    (DATECODE_Begin + DATECODE_Today)
#define DATECODE_BeginSelect   (DATECODE_Begin + DATECODE_Select)

#define DATECODE_EndTNone       (DATECODE_End   + DATECODE_None)
#define DATECODE_EndTSelect     (DATECODE_End   + DATECODE_Select)
#define DATECODE_BeginTNone     (DATECODE_Begin + DATECODE_None)
#define DATECODE_BeginTSelect   (DATECODE_Begin + DATECODE_Select)


// mupo.options.mainview:
#define MAINVIEW_NORMAL           0
#define MAINVIEW_ONLYACTIVE       1
#define MAINVIEW_SEARCHRESULTS    2
#define MAINVIEW_CALENDAR         3
#define MAINVIEW_BEFOREONLYACTIVE 4
//
#define MAINVIEW_ADD_KBD          42

// 
#define RECTYPE_NONE            0
#define RECTYPE_DAILY           1
#define RECTYPE_DAILYRESET      2
#define RECTYPE_WEEKLY          3
#define RECTYPE_MONTHLYDAY      4
#define RECTYPE_MONTHLYDATE     5
#define RECTYPE_YEARLY          6

#define SETCOMPLCODE_OK                          0
#define SETCOMPLCODE_OK_RECTODO                  1
#define SETCOMPLCODE_CURDATE_BEFORE_RECSTART    -1
#define SETCOMPLCODE_ERROR                      -2


#define CALFIRSTDAY_TODAY    0
#define CALFIRSTDAY_SELECT   1
#define CALFIRSTDAY_DECL     2
#define CALFIRSTDAY_INCL     3
#define CALFIRSTDAY_DEC      4
#define CALFIRSTDAY_INC      5


#define FREEDAYSTRING "@b"


#ifdef LARGESCREEN
#define SIZEMUL 2
#define TEXTSIZE1 20
#define TEXTSIZE2 10
#define DEFAULT_WINSIZE_MUL 2
#else
#define SIZEMUL 1
#define TEXTSIZE1 10
#define TEXTSIZE2  8
#define DEFAULT_WINSIZE_MUL 2
#endif

#define AQWSIZE           60
#define AQWBRDRLEFT       30
#define AQWBRDRRIGHT      10
#define TEXTSIZEAQWSTATUS 10

// vorher k anstatt H
#define DATEFORMATSTR  "%d.%m.%Y"
#define TIMEFORMATSTR  "%H:%M"



#ifdef _MSC_VER
#define localtime_r( _clock, _result ) ( *(_result) = *localtime((_clock) ), (_result) )
#endif
