#ifndef __RECURRENCE_H
#define __RECURRENCE_H

#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>
#include <FL/Fl_Choice.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Menu_Button.H>

#include "types.h"

class RecurrenceSelect
{
  public:
   RecurrenceSelect(T_recData*,int,int,int,bool);
   
  private:
   T_recData*  pRecData;
   char        explStr[200];
   
   Fl_Box*     explBox;
   Fl_Box*     timeBox;
   Fl_Choice*  recTypeBox;
      
   Fl_Window*  win;
   Fl_Button*  doneB;

   Fl_Menu_Button*  BegDateB;
   Fl_Menu_Button*  EndDateB;
   Fl_Box*          EndBox;
   Fl_Box*          BegBox;
   char             endStr[11];
   char             begStr[11];
   
   Fl_Box*          intBox;
   char             intStr[5];
   
   int              nDay;
   int              nMonth;
   int              nDOW;
   bool             fToDo;

   inline void cb_Window_i(Fl_Window*, void*);
   static void cb_Window(Fl_Window*, void*);   

   inline void cb_Cancel_i(Fl_Button*, void*);
   static void cb_Cancel(Fl_Button*, void*);   

   inline void cb_Done_i(Fl_Button*, void*);
   static void cb_Done(Fl_Button*, void*);

   inline void cb_Int_i(Fl_Repeat_Button*, void*);
   static void cb_Int(Fl_Repeat_Button*, void*);
  
   void dispExpl();
   void dispDates();
   void dispInt();
   void check_active();
   
  public:
   void show();
   void hide();
   int visible();
   inline void cb_recType_i(Fl_Choice*, void*);
   inline void cb_Date_i(Fl_Menu_*, void*);
};


#endif
