#include "specdays.h"

#include "config.h"
#include "tools.h"
#include <cstring>
#include <cstdlib>

SpecialDays::SpecialDays()
{
  nCurYear = 0;
  fillFixedLists();
}
   
SpecialDays::~SpecialDays()
{
  clearList(fixed);
  clearList(var);
  clearList(fixedFree);
  clearList(varFree);
}

void SpecialDays::clearList(std::vector<T_SpecDay>& list)
{
//  printf("kill\n");
  while (list.size())
    {
      free(list[list.size()-1].descr);
      list.pop_back();
    }
//  printf("killed\n");
}

void SpecialDays::addToList(std::vector<T_SpecDay>& list, 
                            int                     day,
                            int                     month,
                            const char*             descr)
{
  T_SpecDay  tmp;
  
  tmp.descr = (char*)malloc(strlen(descr)+1);
  strcpy(tmp.descr, descr);
  tmp.nDay   = day;
  tmp.nMonth = month;
  
  list.push_back(tmp);
}


#include "specdays_locale.cpp"

