#ifndef __SPECDAYS_H
#define __SPECDAYS_H

#include "types.h"
#include <vector>

class SpecialDays {
  public:
   int                        nCurYear;   
   std::vector<T_SpecDay>     fixedFree;
   std::vector<T_SpecDay>     fixed;
   std::vector<T_SpecDay>     varFree;
   std::vector<T_SpecDay>     var;
      
   SpecialDays();   
   ~SpecialDays();
   void clearList(std::vector<T_SpecDay>& list);
   void fillVarLists(int year);
      
  private:
   void fillFixedLists();
   void addToList(std::vector<T_SpecDay>& list, 
                  int                     day,
                  int                     month,
                  const char*             descr);
};
#endif  // __SPECDAYS_H
