#ifndef __TIMESELECT_H
#define __TIMESELECT_H

#include <FL/Fl_Window.H>
#include <FL/Fl_Box.H>

class TimeSelect
{
  public:
   TimeSelect(int* hour,
              int* minute);
   
  private:
   int*  pnHour;
   int*  pnMinute;
   char  tStr[5];
   
   Fl_Box* timeBox;
      
   Fl_Window*  win;
   Fl_Button*  doneB;
     
   inline void cb_Window_i(Fl_Window*, void*);
   static void cb_Window(Fl_Window*, void*);   

   inline void cb_Cancel_i(Fl_Button*, void*);
   static void cb_Cancel(Fl_Button*, void*);   

   inline void cb_Done_i(Fl_Button*, void*);
   static void cb_Done(Fl_Button*, void*);

   inline void cb_Hour_i(Fl_Button*, void*);
   static void cb_Hour(Fl_Button*, void*);
   
   inline void cb_Minute_i(Fl_Button*, void*);
   static void cb_Minute(Fl_Button*, void*);
  
   void dispTime();
   
  public:
   void show();
   void hide();
   int visible();
};


#endif
