// -*- mode: c; mode: fold -*-

#include "todolistitem.h"
#include <stdlib.h>
#include "tools.h"
#include "config.h"

#define _DEBUGSNOW
#ifdef DEBUGSNOW
#include <stdio.h>
#endif


ToDoListItem::ToDoListItem(unsigned int      ID,
			   std::string       pathInit) 
{
#ifdef DEBUGSNOW
  printf("ToDoListItem::ToDoListItem() 1\n");
  printf("%i %s\n", ID, pathInit.c_str());
#endif
  uID      = ID;
  path     = pathInit;
  
  uPriority = INITIALPRIORITY;
  uSyncID   = 0;
  summary   = "<unnamed>";
  
  fHasBeenSaved = false;
#ifdef MUPOSYNC
  uSyncFlag        = 0;
  fShouldBeDeleted = false;
  fMustBeKept      = false;
#endif
#ifdef DEBUGSNOW
  printf("ToDoListItem::ToDoListItem() 2\n");
#endif
}


ToDoListItem::ToDoListItem(const ToDoListItem& init) 
{
}


ToDoListItem::~ToDoListItem() 
{
}

void ToDoListItem::readContent(std::ifstream& ifile) 
{
}


unsigned int ToDoListItem::getID() 
{
  return(uID); 
}


std::string  ToDoListItem::getPath() 
{
  return(path);
}


void         ToDoListItem::setID(unsigned int id) 
{
  uID = id;
}


void         ToDoListItem::setPath(std::string p) 
{
  path = p;
}


void  ToDoListItem::dump() 
{

}


#ifdef MUPOSYNC
bool ToDoListItem::checkDiff(ToDoListItem* pOthersRoot) 
{
  return(true);
}


void         ToDoListItem::setMustBeKept() 
{ 
  fMustBeKept      = true; 
}


void ToDoListItem::setShouldBeDeleted() 
{
  fShouldBeDeleted = true; 
}


bool         ToDoListItem::getMustBeKept() 
{
  return(fMustBeKept);     
}


bool         ToDoListItem::getShouldBeDeleted() 
{
  return(fShouldBeDeleted);
}


unsigned int ToDoListItem::getSyncFlag() 
{ 
  return(uSyncFlag);       
}

#endif

unsigned int ToDoListItem::getSyncID() 
{
  return(uSyncID);         
}


void         ToDoListItem::setSyncID(unsigned int n) 
{ 
  uSyncID          = n;    
}


void         ToDoListItem::setSummary(std::string n) 
{
  summary   = n;           
}


std::string  ToDoListItem::getSummary() 
{
  return(summary);         
}


void         ToDoListItem::setPriority(unsigned int n) 
{
  uPriority = n;           
}


unsigned int ToDoListItem::getPriority() 
{
  return(uPriority);       
}


bool         ToDoListItem::hasBeenSaved() 
{
  return(fHasBeenSaved);
}


void         ToDoListItem::hasBeenSaved(bool fHBS) 
{
  fHasBeenSaved = fHBS;
}








