#ifndef TWOFISH_H
# define TWOFISH_H

/**
 * Just a wrapper around some kind of twofish code.
 * Currently it wraps Bruce Schneier's http://www.schneier.com/code/twofish-optimized-c.zip
 */
class Twofish
{
public:
  
  /**
   * nInLen/nKeyLen/nOutLen in Bytes
   */
  static unsigned char* Encrypt(const unsigned char* input, int nInLen, 
                                const unsigned char* key,   int nKeyLen,
                                int& nOutLen,
                                bool fIV = false);

  /**
   * nInLen/nKeyLen/nOutLen in Bytes
   */
  static unsigned char* Decrypt(const unsigned char* input, int nInLen, 
                                const unsigned char* key,   int nKeyLen,
                                int& nOutLen,
                                bool fIV = false);
};

#endif
